# oor/kernel.py
#
#

""" basic package for the program. """

__copyright__ = "Copyright 2014 B.H.J Thate"

## IMPORTS

from oor.utils import make_opts, hello
from oor.dispatch import Dispatcher
from oor.defaults import cfg_kernel
from oor.defines import opts_defs
from oor.plugins import Plugins
from oor.object import Object
from oor.log import init

import logging
import os

## RUNTIME

def boot():
    opts, args = make_opts(opts_defs)
    cfg = Object()
    cfg.update(cfg_kernel)
    cfg.update(vars(opts))
    cfg.runargs = args
    kernel = Object()
    kernel.cfg = cfg
    kernel.plugs = Plugins()
    kernel.services = Plugins()
    kernel.bots = Plugins()
    kernel.cmnds = Dispatcher()
    kernel.ctrl = Dispatcher()
    kernel.workers = Dispatcher()
    kernel.run = Object()
    return kernel

## SHUTDOWN

def shutdown(*args, **kwargs):
    """ close the program in a appropiate manner. """
    if cfg.shell: print("") ; logging.warn("exit") 
    os._exit(0)

